﻿Option Strict On

Imports System.Net.Http
Imports Windows.Storage.Streams
Imports System.Net
Imports Windows.Storage
Imports Windows.Data.Xml.Dom
Imports Windows.UI.Xaml.Shapes
Imports Windows.UI

' 空白ページのアイテム テンプレートについては、http://go.microsoft.com/fwlink/?LinkId=234238 を参照してください

''' <summary>
''' それ自体で使用できる空白ページまたはフレーム内に移動できる空白ページ。
''' </summary>
Public NotInheritable Class MainPage
    Inherits Page

    ''' <summary>
    ''' このページがフレームに表示されるときに呼び出されます。
    ''' </summary>
    ''' <param name="e">このページにどのように到達したかを説明するイベント データ。Parameter 
    ''' プロパティは、通常、ページを構成するために使用します。</param>
    ''' 画像サイズは640×480の画像
    Const AppID As String = "66f54a0b48f1b648356c8528e64e4b79"
    Dim myImageList As New List(Of String)
    Dim selectImageUri As String
    Dim myEllipseLeft As Ellipse
    Dim myEllipseRight As Ellipse

    Private Async Sub serverButton_Click(sender As Object, e As RoutedEventArgs) Handles serverButton.Click

        Dim myStorageFolder As StorageFolder = Windows.Storage.KnownFolders.DocumentsLibrary
        Dim myXmlFile As StorageFile = Await myStorageFolder.GetFileAsync("ImageFileList.xml")
        Dim mySetting As New XmlLoadSettings
        mySetting.ProhibitDtd = False
        mySetting.ResolveExternals = False
        Dim xmldoc = Await XmlDocument.LoadFromFileAsync(myXmlFile, mySetting)
        Dim ImageElement As XmlNodeList = xmldoc.SelectNodes("//画像名")

        For i As Integer = 0 To ImageElement.Count - 1
            Dim myElement = ImageElement.ElementAt(i).InnerText
            myImageList.Add(myElement)
            Dim myUrl = "http://2008r2.projectkyss.net/ImageFileUpload/ImageData/" & myElement
            Dim myRequest = HttpWebRequest.CreateHttp(myUrl)
            myRequest.Method = "GET"
            Using myResponse = Await myRequest.GetResponseAsync
                Using myStream = myResponse.GetResponseStream
                    Dim myMemory As New InMemoryRandomAccessStream
                    Dim myOutput As IOutputStream = myMemory.GetOutputStreamAt(0)
                    Await RandomAccessStream.CopyAsync(myStream.AsInputStream, myOutput)
                    Dim bmp As New BitmapImage
                    bmp.SetSource(myMemory)
                    Dim myImage As New Image
                    myImage.Width = 320
                    myImage.Height = 240
                    myImage.Source = bmp
                    GridView1.Items.Add(myImage)
                End Using
            End Using
        Next
    End Sub

    Private Sub GridView1_SelectionChanged(sender As Object, e As SelectionChangedEventArgs) Handles GridView1.SelectionChanged

        Dim selectImage As String = myImageList(GridView1.SelectedIndex)
        selectImageUri = "http://2008r2.projectkyss.net/ImageFileUpload/ImageData/" & selectImage
        Image1.Source = New BitmapImage(New Uri(selectImageUri, UriKind.Absolute))
        glassesButton.IsEnabled = True

    End Sub

    Private Async Sub glaseesButton_Click(sender As Object, e As RoutedEventArgs) Handles glassesButton.Click
        Dim imageUri As String = String.Format("https://kaolabo.com/api/detect?apikey={0}&url={1}", AppID, selectImageUri)

        Dim myHttpClient As New HttpClient
        Dim result = Await myHttpClient.GetStringAsync(New Uri(imageUri, UriKind.Absolute))
        result = result.Replace("<results version=" & ChrW(34) & "1.0" & ChrW(34) & " xmlns=" & ChrW(34) & "http://xmlns.kaolabo.com/detect" & ChrW(34) & ">", "<results>")

        Dim readXmldoc As XElement = XElement.Parse(result)
        Dim x_no As Integer = 0
        Dim y_no As Integer = 0
        For Each myResult In From c In readXmldoc.Descendants("face") Select c
            Dim left_eyeX = CInt(CInt(myResult.Element("left-eye").Attribute("x").Value))
            Dim left_eyeY = CInt(CInt(myResult.Element("left-eye").Attribute("y").Value))
            Dim faceHeight = CInt(myResult.Attribute("height").Value)
            Dim right_eyeX = CInt(CInt(myResult.Element("right-eye").Attribute("x").Value))
            Dim right_eyeY = CInt(CInt(myResult.Element("right-eye").Attribute("y").Value))

            myEllipseRight = New Ellipse

            If faceHeight <= 100 Then
                x_no = 20
                y_no = 15
            Else
                x_no = 20
                y_no = 40
            End If
            With myEllipseRight
                .Fill = New SolidColorBrush(Colors.Gray)
                .SetValue(Canvas.LeftProperty, right_eyeX - x_no)
                .SetValue(Canvas.TopProperty, right_eyeY - y_no)
                .Width = CInt(faceHeight / 4)
                .Height = CInt(faceHeight / 4)
                .Stroke = New SolidColorBrush(Colors.Black)
                .StrokeThickness = 2
                .Opacity = 0.8
            End With

            myEllipseLeft = New Ellipse
            With myEllipseLeft
                .Fill = New SolidColorBrush(Colors.Gray)
                .SetValue(Canvas.LeftProperty, left_eyeX - x_no)
                .SetValue(Canvas.TopProperty, left_eyeY - y_no)
                .Width = faceHeight / 4
                .Height = faceHeight / 4
                .Stroke = New SolidColorBrush(Colors.Black)
                .StrokeThickness = 2
                .Opacity = 0.8
            End With
            myCanvas.Children.Add(myEllipseRight)
            myCanvas.Children.Add(myEllipseLeft)
        Next
    End Sub

    Private Sub clearButton_Click(sender As Object, e As RoutedEventArgs) Handles clearButton.Click
        myEllipseLeft.Visibility = Xaml.Visibility.Collapsed
        myEllipseRight.Visibility = Xaml.Visibility.Collapsed
    End Sub
End Class
